/*
 * Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
 *
 * SPDX-License-Identifier: MPL-2.0
 */

fieldset {
  min-width: 0;
  margin: 0;
  padding: 0;
  border: 0;
}
dl {
  margin-top: 0;
  margin-bottom: 1em;
}
dt {
  font-weight: 500;
}
dd {
  margin-bottom: 0.5em;
  margin-left: 0;
}
.ant-form {
  h1,
  h2,
  h3,
  h4,
  h5 {
    margin-top: 30px;
    margin-bottom: @form-item-margin-bottom;
  }
  font-size: @platform-main-font-size;
}

.ant-btn {
  line-height: 1.8rem;
  &[disabled],
  &[disabled]:hover {
    color: @links-grey-color !important;
    border-color: @links-grey-color !important;
  }
  &:hover {
    .general-button-layout;
    color: @platform-btn-primary-color !important;
    background-color: @text-color;
    border-color: @text-color;
  }
  &:focus,
  &:focus-visible {
    .general-button-layout;
    .general-outline-layout;
    color: @platform-btn-primary-color !important;
    background-color: @text-color;
    border-color: @text-color !important;
  }
  &.ant-btn-primary {
    &:active {
      color: @btn-primary-color;
      background-color: @platform-btn-primary-bg;
    }
    &[disabled] {
      color: @platform-btn-primary-color !important;
      background-color: @links-grey-color !important;
    }
  }
  &.ant-btn-default {
    &[disabled] {
      background-color: #e9eaf3;
      color: #555555 !important;
    }
    &:not(:disabled) {
      &:not(.ant-btn-disabled) {
        &:hover {
          background-color: @text-color;
        }
      }
    }
  }
  &.ant-btn-text,
  &.ant-btn-link {
    padding: 0 2px;
    height: auto;
    user-select: text;
    color: @platform-text-color;
    &:hover,
    &:focus {
      border-color: transparent;
      box-shadow: none;
      color: @platform-btn-primary-color;
      background: @text-color !important;
    }
    &:active {
      background: @platform-blue1;
    }
    &[disabled] {
      border-color: transparent !important;
      color: @text-disabled-blue-4-bg;
      &:hover {
        background: transparent !important;
      }
    }
    &.ant-popover-open {
      background: @platform-blue1;
      color: @platform-btn-primary-color;
    }
  }
}

.ant-menu-item-disabled {
  .ant-menu-title-content {
    color: @text-disabled-color;
  }
  .ant-btn {
    pointer-events: none;
  }
}

.ant-tabs-tab {
  .ant-tabs-tab-btn {
    padding: 4px 2px;
    &:hover,
    &:focus {
      color: white;
      background-color: black;
    }
    &:focus {
      .general-outline-layout;
    }
  }
  &:hover {
    .ant-tabs-tab-btn {
      color: white !important;
      background-color: black;
    }
  }
}

.ant-tabs-tab {
  font-weight: 500;
  text-shadow: none;
  &.ant-tabs-tab-active {
    .ant-tabs-tab-btn {
      color: @platform-blue1;
      text-shadow: none !important;
      &:hover,
      &:focus {
        color: white;
      }
    }
  }
  &.ant-tabs-tab-disabled {
    color: #6a6868 !important;
  }
}

.ant-table-wrapper {
  a {
    color: @platform-blue1;
    &:hover {
      color: white;
    }
  }
  .ant-table-column-sorter-down,
  .ant-table-column-sorter-up {
    color: #b3b3bf;
    &.active {
      color: @platform-blue1;
    }
  }
  .ant-table-column-has-sorters:focus {
    border: 2px solid @platform-blue1 !important;
    border-radius: 3px;
    padding: 1.4rem;
  }
}

.ant-form-item {
  .ant-form-item-label {
    padding-top: 4px;
    margin-top: -4px;
    overflow: visible;

    // ensures that required * is not centered vertically for multiline label
    & > label {
      display: inline;
    }
    font-weight: 500;
    & > label.ant-form-item-required:not(.ant-form-item-required-mark-optional) {
      &::before {
        display: none;
      }
      &:after {
        display: inline-block;
        margin-right: 4px;
        font-size: 1.8rem;
        line-height: 1;
        content: '*';
      }
    }
  }
  &.ant-form-item-has-error {
    border-left: 6px solid @platform-validation-red;
    margin-left: -20px;
    padding-left: 14px;
    margin-bottom: 24px !important;
    .ant-form-item-label {
      margin-bottom: -8px;
    }
    .ant-form-item-control {
      display: flex;
      -webkit-border-vertical-spacing: 8px;
      .ant-upload-list {
        height: 0;
      }
    }
    .ant-form-item-explain {
      margin: 0;
      order: 1;
    }
    .ant-form-item-control-input {
      order: 2;
      input {
        border-color: #aa0000 !important;
      }
    }
    .ant-input,
    .ant-picker {
      &:hover,
      &:focus {
        .form-hover-focus(@platform-validation-red);
      }
    }
    .ant-picker-focused {
      .form-hover-focus(@platform-validation-red);
    }
    .ant-select:not(.ant-select-disabled):hover,
    .ant-select:not(.ant-select-disabled):focus,
    .ant-select-focused:not(.ant-select-disabled).ant-select-single:not(.ant-select-customize-input),
    .ant-select-focused:not(.ant-select-disabled).ant-select-multiple:not(.ant-select-customize-input) {
      .ant-select-selector {
        .form-hover-focus(@platform-validation-red);
      }
    }
  }
  &.has-hinweis {
    .ant-form-item-control-input {
      order: 2;
    }
    .ant-form-item-extra {
      margin: 0;
      order: 1;
    }
  }
}

.ant-form-item-explain.ant-form-item-explain-error {
  color: @platform-validation-red;
}

.ant-input,
.ant-picker,
.ant-input-affix-wrapper:not(.ant-input-affix-wrapper-disabled):hover {
  font-size: @platform-main-font-size;
  &:hover,
  &:focus {
    .form-hover-focus;
  }
}
.ant-input-affix-wrapper {
  .ant-input {
    box-shadow: none;
  }
}
.ant-picker-focused,
.ant-input-affix-wrapper-focused {
  .form-hover-focus;
}
.ant-form-item-control-input {
  input.ant-input {
    line-height: 40px;
  }
  textarea.ant-input {
    border-color: @platform-blue2;
    border-radius: 3px;
  }
}

.ant-select:not(.ant-select-disabled):hover,
.ant-select:not(.ant-select-disabled):focus,
.ant-select-focused:not(.ant-select-disabled).ant-select-single:not(.ant-select-customize-input),
.ant-select-focused:not(.ant-select-disabled).ant-select-multiple:not(.ant-select-customize-input) {
  .ant-select-selector {
    .form-hover-focus;
  }
}
.ant-select-show-arrow {
  .ant-select-arrow {
    color: unset;
  }
}

.ant-select-disabled {
  > .ant-select-selector {
    border: 1px #808080 solid !important;
  }
}

.ant-select-dropdown {
  .ant-select-item-option {
    padding: 5px 12px;
    min-height: 22px;
  }
  .ant-select-item-option-content {
    white-space: normal;
    font-size: 1.8rem !important;
  }
  .ant-select-item-option-selected {
    text-decoration: none !important;
    background-color: @platform-blue4;
  }
  .ant-select-item-option-active {
    text-decoration: underline;
    background-color: @platform-blue4;
  }
  .ant-select-item-group {
    color: #000;
    font-size: 1.4rem;
    font-weight: 500;
  }
}

.ant-tree-select-dropdown {
  padding: 4px 0;
  .ant-select-tree-treenode {
    padding: 0 !important;
    width: 100%;
    .ant-select-tree-switcher-icon {
      vertical-align: baseline !important;
    }
    .ant-select-tree-node-content-wrapper {
      border-radius: 0;
      min-height: 32px;
      padding: 5px 12px !important;
      width: 100%;
      &:hover {
        background-color: @platform-blue4 !important;
        text-decoration: underline;
      }
    }

    .ant-select-tree-node-selected {
      font-weight: 600;
    }
  }
  .ant-select-tree-checkbox {
    .ant-select-tree-checkbox-inner {
      height: 20px;
      width: 20px;
      background-color: #ffffff;
      border: 1px solid #0032d9;
      border-radius: 2px;
      &:after {
        width: 7.142857142857143px;
        height: 11.428571428571429px;
      }
      &:hover {
        border-color: #000 !important;
      }
    }
    &.ant-select-tree-checkbox-checked {
      .ant-select-tree-checkbox-inner {
        background-color: #000;
        border-color: #000;
        &:hover {
          background-color: #000;
        }
      }
    }
    &.ant-select-tree-checkbox-indeterminate {
      .ant-select-tree-checkbox-inner {
        &:after {
          background-color: #000;
          width: 12px;
          height: 12px;
        }
      }
    }
  }
}

.ant-select-selection-placeholder {
  color: black !important;
}

.ant-checkbox-wrapper {
  font-size: @platform-main-font-size;
  margin-inline-start: 0 !important;
  .ant-checkbox-input:focus + .ant-checkbox-inner {
    outline: 2px solid @platform-blue2;
    outline-offset: 2px;
  }
  &.ant-checkbox-wrapper-disabled {
    .ant-checkbox-disabled {
      .ant-checkbox-inner {
        background: rgba(0, 0, 0, 0.2);
        &:after {
          border-color: #fff;
        }
      }
    }
  }
}
.ant-radio-wrapper {
  &:hover {
    .ant-radio-inner {
      border-color: @platform-blue1;
    }
  }
  .ant-radio {
    display: block;
    &:after {
      display: none;
    }
  }

  .ant-radio-disabled {
    + span {
      color: @text-disabled-color;
    }
    .ant-radio-inner {
      border-color: @text-disabled-color !important;
      background-color: #f5f5f5;
    }
  }

  .ant-radio-inner {
    margin: 0 auto;
  }
  .ant-radio-input:focus + .ant-radio-inner {
    outline: 2px solid @platform-blue2;
    outline-offset: 2px;
  }
  .ant-radio-checked {
    .ant-radio-inner {
      border-color: @platform-blue1;
      &:after {
        transform: scale(0.6);
        border: 1rem solid black;
      }
    }
  }
}
.horizontal-radios {
  display: block;
  .ant-radio-wrapper {
    display: table;
    margin: 0 0 10px;
    .ant-radio {
      display: inline-block;
      top: 3px;
    }
  }
}

.ant-popconfirm {
  .anticon {
    top: 22%;
  }
  .ant-popover-buttons {
    display: flex;
    text-align: left;
    .ant-btn {
      order: 2;
    }
    .ant-btn-primary {
      order: 1;
      margin-left: 0;
    }
  }
  .ant-popover-message-title {
    font-size: 1.6rem;
    font-weight: 500;
  }
}

.ant-popover {
  .ant-popover-title {
    padding-top: 17px;
    border: none;
    .ant-popover-message-title {
      font-size: 1.8rem;
      padding-left: 18px;
    }
  }
  .ant-popover-buttons {
    width: fit-content;
    button:first-of-type {
      margin-left: 0;
    }
    button:not(:first-child) {
      margin-left: 8px;
    }
  }
}

.ant-switch:focus {
  outline: 2px solid @platform-blue2;
  outline-offset: 2px;
}

.ant-message {
  top: 160px !important;
  font-size: 1.6rem;
  line-height: 24px;
  .ant-message-notice {
    padding: 16px 0 0 0;
    .ant-message-notice-content {
      box-shadow: 0px 2px 8px #00000029;
      border-radius: 2px;
      position: relative;
      padding-right: 48px;
      .close-icon {
        position: absolute;
        top: 10px;
        right: 10px;
        line-height: 0;
        padding: 7px;
        cursor: pointer;
        .anticon {
          width: 9px;
          height: 9px;
          color: #000;
          margin: 0;
        }
      }
    }
    &.custom-success-message {
      .ant-message-notice-content {
        background: #f0ffeb;
        border: 1px solid #77b066;
      }
    }

    &.custom-error-message {
      .ant-message-notice-content {
        background: #ffe6e6;
        border: 1px solid #aa0000;
      }
    }
  }
  span {
    font-size: 1.6rem !important;
  }
}

.heading-holder {
  background-color: #fff;
  padding: 24px 0;
  h1,
  h2,
  h3,
  h4,
  h5,
  h6 {
    display: inline;
    margin: 0;
    font-weight: 500;
    font-family: @platform-font-family;
  }
  margin-bottom: 52px;
}

[class^='ant-typography'],
[class*=' ant-typography'] {
  font-family: @platform-font-family;
  font-size: @platform-main-font-size;
}

h1,
h2,
h3,
h4,
h5,
h6 {
  &.ant-typography {
    font-weight: 500;
    font-family: @platform-font-family;
  }
}
h1.ant-typography {
  margin-top: 30px;
  font-size: 2.4rem;
  margin-bottom: 32px;
}

h2.ant-typography {
  margin-bottom: 25px;
  margin-top: 35px;
  font-size: 2rem;
}

h3.ant-typography {
  margin-top: 40px;
  font-size: 1.8rem;
}
h4.ant-typography {
  font-size: 1.8rem;
}
h5.ant-typography {
  font-size: 1.6rem;
}

h2.ant-typography + h3.ant-typography {
  margin-top: 25px;
}

.ant-typography {
  & > .anticon:first-child {
    margin-right: 8px;
  }
  a&:focus,
  & a:focus,
  a&:hover,
  & a:hover {
    color: @platform-btn-primary-color;
  }
  strong {
    font-weight: 500;
  }
}

.ant-picker {
  width: 100%;
  line-height: 40px;
  .ant-picker-input {
    input {
      line-height: 40px;
    }
  }
  .ant-picker-clear {
    padding: 5px;
  }
  .ant-picker-suffix {
    padding: 5px;
    svg {
      path {
        fill: @platform-blue1;
      }
    }
  }
  &.ant-picker-focused {
    .ant-picker-suffix {
      background-color: @platform-blue1;
      svg {
        path {
          fill: white;
        }
      }
    }
  }
}

.ant-picker-dropdown {
  font-size: 1.4rem;
  .ant-picker-cell-inner,
  .ant-picker-cell-inner::after,
  .ant-picker-cell::before {
    transition: none !important;
  }
  .ant-picker-header {
    padding: 0;
    button {
      color: black;
      &:hover {
        color: white;
        background-color: black;
      }
    }
    .ant-picker-header-view {
      button {
        margin-left: 0 !important;
        padding: 0 5px;
        font-weight: normal;
      }
    }
  }
  .ant-picker-cell-today {
    .ant-picker-cell-inner::before {
      border-color: @platform-blue1;
    }
    &:hover {
      .ant-picker-cell-inner::before {
        content: none;
      }
    }
  }
  .ant-picker-cell-selected {
    .ant-picker-cell-inner {
      background-color: @platform-blue1;
    }
  }
  .ant-picker-cell-range-hover-start,
  .ant-picker-cell-range-hover-end,
  .ant-picker-cell-range-start.ant-picker-cell-in-view,
  .ant-picker-cell-range-end.ant-picker-cell-in-view {
    &:hover {
      color: white;
      &::before {
        background: black !important;
      }
      .ant-picker-cell-inner {
        background: black !important;
        &::after {
          background: black !important;
        }
      }
    }
  }

  .ant-picker-cell {
    &:hover:not(&-in-view),
    &:hover:not(&-selected):not(&-range-start):not(&-range-end):not(&-range-hover-start):not(&-range-hover-end) {
      .ant-picker-cell-inner {
        background: black;
        color: white;
        &::before {
          border: none;
          background: black;
        }
      }
    }
  }
  .ant-picker-time-panel {
    .ant-picker-content {
      .ant-picker-time-panel-cell {
        &.ant-picker-time-panel-cell-selected {
          .ant-picker-time-panel-cell-inner {
            background-color: @platform-blue1;
            color: white;
          }
        }
        .ant-picker-time-panel-cell-inner {
          &:hover {
            background: black;
            color: white;
          }
        }
      }
    }
  }
}

.ant-picker-range {
  .ant-picker-active-bar {
    background: @platform-blue1;
    height: 4px;
  }
}

.ant-picker-dropdown-range {
  .ant-picker-range-arrow {
    display: none;
  }
  .ant-picker-body {
    .ant-picker-cell-range-start.ant-picker-cell-in-view,
    .ant-picker-cell-range-end.ant-picker-cell-in-view {
      &::after,
      &::before {
        background: @platform-blue1;
      }
      .ant-picker-cell-inner {
        background: @platform-blue1;
      }
    }
  }

  .ant-picker-footer {
    padding: 16px;
    .ant-picker-footer-extra {
      .range-picker-close {
        margin: auto;
        display: block;
      }
    }
  }
}

.ant-input-search &.ant-input {
  &:hover,
  &:focus {
    .form-hover-focus;
  }
}

.ant-tag {
  margin-bottom: 3px;
  background: none;
  padding: 0 3px;
  white-space: normal;
  display: inline-flex;
  &.ant-tag-blue {
    border-color: @platform-blue1;
  }
  &.ant-tag-red {
    color: @platform-red1;
    border-color: @platform-red1;
    .ant-tag-close-icon {
      color: @platform-red1;
    }
  }
  .ant-tag-close-icon {
    color: @platform-blue1;
    align-self: center;
    padding: 2px;
    font-size: 0.7rem;
    line-height: 8px;
    display: inline-block;
    &:hover {
      color: #fff;
      background-color: #000;
    }
  }
}

.ant-select-multiple {
  .ant-select-selector {
    padding: 6px 6px 3px 6px;
    small {
      display: none;
    }
    &:after {
      line-height: 30px;
    }
  }
  .ant-select-selection-search-input,
  .ant-select-selection-search-mirror {
    height: 26px;
    line-height: 26px;
  }
  .ant-select-selection-overflow-item {
    align-self: auto;
  }
}
.ant-picker-time-panel-column {
  width: 70px;
}

.ant-modal-root {
  .ant-modal-wrap {
    .ant-modal-content {
      padding: 0;
      .ant-modal-header {
        min-height: 55px;
        padding: 16px 24px;
        color: #000;
        background: #fff;
        border-bottom: 1px solid #0032d9;
        border-radius: 3px 3px 0 0;
        margin: 0;
      }
      .ant-modal-close {
        color: @platfotm-shuttle-gray;
        margin: 20px 24px;
        top: 0;
        right: 0;
        &:hover,
        &:focus {
          color: white;
        }
        &:hover {
          background-color: black;
        }
        &:focus {
          background-color: black;
          outline: 2px solid black;
        }
        .ant-modal-close-x {
          &:hover {
            color: white;
          }
        }
      }
      .ant-modal-title {
        font-weight: 500;
        padding-right: 36px;
        h3 {
          font-size: 2rem;
          line-height: 22px;
          margin: 0;
        }
      }
      .ant-modal-body {
        padding: 4px 24px;
        font-size: 1.8rem;
        line-height: 26px;
        word-wrap: break-word;
        .hinweis-component {
          width: auto;
          margin: 12px -24px;
        }
      }
      .ant-modal-footer {
        border-top: 1px solid @platform-blue1;
        padding: 10px 16px;
      }
    }
  }
}

.ant-pagination-item-link {
  border: none !important;
  color: #000;
  & > .anticon svg:hover,
  &.anticon svg:focus-visible,
  &.anticon svg:focus {
    color: @link-hover-color;
  }
  &:hover {
    background-color: @link-color;
    color: @link-hover-color;
  }
  &:focus,
  &:focus-visible {
    background-color: #000;
    color: #fff;
    outline-style: dotted;
    outline-color: #000;
    outline-width: 1px;
    outline-offset: 2px;
  }
}

.ant-pagination-item {
  border: none !important;
  text-decoration: none;
  color: @platform-blue2;

  a {
    text-decoration: none !important;
  }
  &:hover {
    background-color: @link-color;
    color: @link-hover-color;
  }
  &:focus-within {
    background-color: #000;
    color: @link-hover-color !important;
    outline-style: dotted;
    outline-color: #000;
    outline-width: 1px;
    outline-offset: 2px;
    a {
      color: @link-hover-color;
    }
  }
}

.ant-pagination-item-active {
  color: @platform-blue2;
  border-radius: unset;
  border-bottom: 2px solid @platform-blue2 !important;

  &:focus,
  &:focus-within,
  &:hover {
    color: @link-hover-color;
  }
}

.ant-layout-content {
  flex: auto;
  min-height: 0;
  z-index: 2;
}
[hidden] {
  display: none !important;
}
.ant-checkbox-group {
  display: inline-block;
}
